/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2005-2008 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */
/*!
 *  \file   toppers/nm_symbol.hpp
 *  \brief  "nm"R}hœV{e[u߂̐錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  class nm_symbol;
 *  \endcode
 */
#ifndef TOPPERS_NM_SYMBOL_HPP_
#define TOPPERS_NM_SYMBOL_HPP_

#include "toppers/config.hpp"
#include <iosfwd>
#include <string>
#include <map>

namespace toppers
{

  /*!
   *  \class  nm_symbol nm_symbol.hpp "toppers/nm_symbol.hpp"
   *  \brief  `nm'R}hœV{e[u߂̃NX
   *
   *  \sa nm_symbol::entry
   */
  class nm_symbol
  {
  public:
    /*!
     *  \struct entry nm_symbol.hpp "toppers/nm_symbol.hpp"
     *  \brief  AhXƃ^Cvi[\
     *
     *  `nm'R}h̏o͌ʂA
     *  \code
     *  01234567 T foo
     *  \endcode
     *  ƂȂꍇA0x01234567 address ɁA'T' type Ɋi[܂B
     */
    struct entry
    {
      unsigned long address;
      int type;
    };

    /*!
     *  \brief  ftHgRXgN^
     */
    nm_symbol() {}
    /*!
     *  \brief  RXgN^
     *  \param  istr  ̓Xg[
     */
    explicit nm_symbol( std::istream& istr ) { load( istr ); }

    void load( std::istream& istr );
    entry const find( std::string const& symbol ) const; 
  private:
    std::map< std::string, entry > symbol_map_;
  };

}

#endif  // ! TOPPERS_NM_SYMBOL_HPP_
